// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from sick_scan_xd:msg/RadarPreHeaderDeviceBlock.idl
// generated code does not contain a copyright notice
#include "sick_scan_xd/msg/detail/radar_pre_header_device_block__rosidl_typesupport_fastrtps_cpp.hpp"
#include "sick_scan_xd/msg/detail/radar_pre_header_device_block__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions

namespace sick_scan_xd
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_sick_scan_xd
cdr_serialize(
  const sick_scan_xd::msg::RadarPreHeaderDeviceBlock & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: uiident
  cdr << ros_message.uiident;
  // Member: udiserialno
  cdr << ros_message.udiserialno;
  // Member: bdeviceerror
  cdr << (ros_message.bdeviceerror ? true : false);
  // Member: bcontaminationwarning
  cdr << (ros_message.bcontaminationwarning ? true : false);
  // Member: bcontaminationerror
  cdr << (ros_message.bcontaminationerror ? true : false);
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_sick_scan_xd
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  sick_scan_xd::msg::RadarPreHeaderDeviceBlock & ros_message)
{
  // Member: uiident
  cdr >> ros_message.uiident;

  // Member: udiserialno
  cdr >> ros_message.udiserialno;

  // Member: bdeviceerror
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.bdeviceerror = tmp ? true : false;
  }

  // Member: bcontaminationwarning
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.bcontaminationwarning = tmp ? true : false;
  }

  // Member: bcontaminationerror
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.bcontaminationerror = tmp ? true : false;
  }

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_sick_scan_xd
get_serialized_size(
  const sick_scan_xd::msg::RadarPreHeaderDeviceBlock & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: uiident
  {
    size_t item_size = sizeof(ros_message.uiident);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: udiserialno
  {
    size_t item_size = sizeof(ros_message.udiserialno);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: bdeviceerror
  {
    size_t item_size = sizeof(ros_message.bdeviceerror);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: bcontaminationwarning
  {
    size_t item_size = sizeof(ros_message.bcontaminationwarning);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: bcontaminationerror
  {
    size_t item_size = sizeof(ros_message.bcontaminationerror);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_sick_scan_xd
max_serialized_size_RadarPreHeaderDeviceBlock(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: uiident
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: udiserialno
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: bdeviceerror
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: bcontaminationwarning
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: bcontaminationerror
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = sick_scan_xd::msg::RadarPreHeaderDeviceBlock;
    is_plain =
      (
      offsetof(DataType, bcontaminationerror) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static bool _RadarPreHeaderDeviceBlock__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const sick_scan_xd::msg::RadarPreHeaderDeviceBlock *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _RadarPreHeaderDeviceBlock__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<sick_scan_xd::msg::RadarPreHeaderDeviceBlock *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _RadarPreHeaderDeviceBlock__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const sick_scan_xd::msg::RadarPreHeaderDeviceBlock *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _RadarPreHeaderDeviceBlock__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_RadarPreHeaderDeviceBlock(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _RadarPreHeaderDeviceBlock__callbacks = {
  "sick_scan_xd::msg",
  "RadarPreHeaderDeviceBlock",
  _RadarPreHeaderDeviceBlock__cdr_serialize,
  _RadarPreHeaderDeviceBlock__cdr_deserialize,
  _RadarPreHeaderDeviceBlock__get_serialized_size,
  _RadarPreHeaderDeviceBlock__max_serialized_size
};

static rosidl_message_type_support_t _RadarPreHeaderDeviceBlock__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_RadarPreHeaderDeviceBlock__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace sick_scan_xd

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_sick_scan_xd
const rosidl_message_type_support_t *
get_message_type_support_handle<sick_scan_xd::msg::RadarPreHeaderDeviceBlock>()
{
  return &sick_scan_xd::msg::typesupport_fastrtps_cpp::_RadarPreHeaderDeviceBlock__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, sick_scan_xd, msg, RadarPreHeaderDeviceBlock)() {
  return &sick_scan_xd::msg::typesupport_fastrtps_cpp::_RadarPreHeaderDeviceBlock__handle;
}

#ifdef __cplusplus
}
#endif
